package com.citizen.app.cpcl;

import java.io.IOException;
import java.io.UnsupportedEncodingException;

import com.citizen.app.assist.CPCLSample2;
import com.citizen.app.cpcl.R;
import com.citizen.app.port.bluetooth.BluetoothConnectMenu;
import com.citizen.jpos.command.CPCLConst;
import com.citizen.jpos.command.ESCPOSConst;
import com.citizen.jpos.printer.CPCLPrinter;

import android.app.AlertDialog;
import android.app.ListActivity;
import android.app.ProgressDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.os.AsyncTask;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.EditText;
import android.widget.LinearLayout;
import android.widget.Spinner;
import android.widget.Toast;
import android.widget.AdapterView.OnItemClickListener;

public class CPCL2Menu extends ListActivity
{
	// Menu
	final static String[] arr = 
	{
		"Barcode",
		"CITIZEN SYSTEM",
		"2D Barcode",
		"Denmark Stamp",
		"Font Test",
		"Font Type Test",
		"Setting Test1",
		"Setting Test2",
		"MULTILINE",
		"Status Check",
		"Emulation Check",
		"Print Android Font",
		"Print Multilingual",
		"Print Results"
	};
	
	private String strCount;
	private Spinner paperSpinner;

	@Override
	protected void onDestroy()
	{
		super.onDestroy();
		Log.d("CPCL2Menu", "OnDestroy");
	}
	
	/** Called when the activity is first created. */
	@Override
	public void onCreate(Bundle savedInstanceState)
	{
		super.onCreate(savedInstanceState);
		setContentView(R.layout.label_sample_menu);
		
		ArrayAdapter<CharSequence> paperAdapter = ArrayAdapter.createFromResource(this, R.array.label_paper, android.R.layout.simple_spinner_item);
        paperAdapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
        paperSpinner = (Spinner) findViewById(R.id.paper_spinner);
        paperSpinner.setAdapter(paperAdapter);
        paperSpinner.setSelection(2);

		
		setListAdapter(new ArrayAdapter<String>(this, android.R.layout.simple_list_item_1 , arr));
		getListView().setOnItemClickListener(new OnItemClickListener()
		{
			@Override
			public void onItemClick(AdapterView<?> arg0, View arg1, int arg2, long arg3)
			{
				dialog(arg2);
			}
		});
	}
	
	// Dialog
	private void dialog(int arg1)
	{
        final int arg2 = arg1; 
		final LinearLayout linear = (LinearLayout)
			View.inflate(CPCL2Menu.this, R.layout.input_popup, null);
		
		final EditText number = (EditText)linear.findViewById(R.id.EditTextPopup);
		if(strCount == null)
			strCount = "1";
		number.setText(strCount);
		
		// except Status. 
		new AlertDialog.Builder(CPCL2Menu.this)
		.setTitle("Test Count.")
		.setIcon(R.drawable.icon)
		.setView(linear)
		.setPositiveButton("OK", new DialogInterface.OnClickListener() {
			public void onClick(DialogInterface dialog, int whichButton) 
			{
				try
				{
			        String Label = null;
					int count = 1;
					int results = 0;
					CPCLSample2 sample = new CPCLSample2();
					strCount = number.getText().toString();
					count = Integer.parseInt(strCount);
					Log.d("NUM",count+"");
					
					int paperType = paperSpinner.getSelectedItemPosition();
					// R.array.label_paper [GAP, BM, CONT]
					switch(paperType)
					{
						case 0:
							sample.selectGapPaper();
							break;
						case 1:
							sample.selectBlackMarkPaper();
							break;
						case 2:
							sample.selectContinuousPaper();
							break;
						default:
					}

					switch(arg2)
					{
						case 0:
							results = sample.barcodeTest(count);
							break;
						case 1:
							results = sample.profile2(count);
							break;
						case 2:
							results = sample.barcode2DTest(count);
							break;
						case 3:
							results = sample.dmStamp(count);
							break;
						case 4:
							results = sample.fontTest(count);
							break;
						case 5:
							results = sample.fontTypeTest(count);
							break;
						case 6:
							results = sample.settingTest1(count);
							break;
						case 7:
							results = sample.settingTest2(count);
							break;
						case 8:
							results = sample.multiLineTest(count);
							break;
						case 9:
							results = sample.statusCheck();
							break;
						case 10:
							String emuls = sample.emulCheck();
							Toast toasts = Toast.makeText(CPCL2Menu.this, emuls, Toast.LENGTH_LONG);
							toasts.show();
							break;
						case 11:
							results = sample.printAndroidFont(count);
							break;
						case 12:
							results = sample.printMultilingualFont(count);
							break;	
						case 13:
							results = sample.printResults(count);
							break;	
						default:
							break;
					}
					if(arg2 != 10)
					{
						String statusMsg;
					
						if(results == CPCLConst.CMP_STS_CPCL_NORMAL)
							statusMsg = new String("Normal");
						else
						{
							statusMsg = new String();
							if((results & CPCLConst.CMP_STS_CPCL_COVER_OPEN) > 0)
								statusMsg = statusMsg + "Cover Open\r\n";
							if((results & CPCLConst.CMP_STS_CPCL_PAPER_EMPTY) > 0)
								statusMsg = statusMsg + "Paper Empty\r\n";
							if((results & CPCLConst.CMP_STS_CPCL_BATTERY_LOW) > 0)
								statusMsg = statusMsg + "Battery Low\r\n";
							if((results & CPCLConst.CMP_STS_CPCL_PRINTEROFF) > 0)
								statusMsg = statusMsg + "Printer Power OFF\r\n";
							if((results & CPCLConst.CMP_STS_CPCL_TIMEOUT) > 0)
								statusMsg = statusMsg + "Timeout error";
						}
						Toast toast = Toast.makeText(CPCL2Menu.this, statusMsg, Toast.LENGTH_SHORT);
						toast.show();
					}
				}
				catch(NumberFormatException e)
				{
					Log.e("NumberFormatException","Invalid Input Nubmer.",e);
				}
				catch(IOException e)
				{
					Log.e("IO Exception", "IO Error",e);	
				}
			}
		})
		.setNegativeButton("Cancel", new DialogInterface.OnClickListener() {
			public void onClick(DialogInterface dialog, int whichButton) 
			{
				Log.d("Cancel", "Cancel Button Clicked.");
			}
		})
		.show();
	}

	private void btPrint(int count) throws IOException
	{
		new connTask().execute(count);
	}

	class connTask extends AsyncTask<Integer, Void, Integer>
	{
		private final ProgressDialog dialog = new ProgressDialog(CPCL2Menu.this);

		@Override
		protected void onPreExecute()
		{
			dialog.setTitle("Printing");
			dialog.setMessage("Now printing...");
			dialog.show();
			super.onPreExecute();
		}
		
		@Override
		protected Integer doInBackground(Integer... params)
		{
			int sts;
			int posY = 56, i=1;
			String japanChar = "ƫȫƫȫƫȫƫȫƫȫƫ";
			
			CPCLPrinter cpclPrinter = new CPCLPrinter("Shift_JIS");
			
			sts = cpclPrinter.printerCheck();
			if(sts != CPCLConst.CMP_SUCCESS) return sts;

			sts = cpclPrinter.status();
			if(sts != CPCLConst.CMP_SUCCESS) return sts;

			cpclPrinter.setForm(0, 203, 203, 1700, params[0]);
			cpclPrinter.setMedia(2);
			cpclPrinter.userString("TONE 0\n");
			cpclPrinter.userString("COUNTRY JAPAN-S\n");
			
			for(i=1; i<50; i++)
			{
		        String bmpPath = "//sdcard//temp//citizen//" + String.format("%05d", i) + "tmpGaijiImg.png";
				try {
					cpclPrinter.printBitmap(bmpPath, 10, posY);
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
//				cpclPrinter.printAndroidFont(10, posY, String.format("%05d", i)+japanChar, 576, 24);
				posY += 30;
			}
			
			try {
				cpclPrinter.printForm();
			} catch (UnsupportedEncodingException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}

			Integer retVal = Integer.valueOf(0);
			return retVal;
		}
		
		protected void onPostExecute(Integer result)
		{
			if(result.intValue() == 0)	// Connection success.
			{
			}
			else	// Connection failed.
			{
			}
			if(dialog.isShowing())
				dialog.dismiss();				
			super.onPostExecute(result);
		}
	}
}