package com.citizen.app.cpcl;

import com.citizen.app.assist.CPCLSample3;
import com.citizen.app.cpcl.R;
import com.citizen.jpos.command.CPCLConst;

import android.app.AlertDialog;
import android.app.ListActivity;
import android.content.DialogInterface;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.EditText;
import android.widget.LinearLayout;
import android.widget.Spinner;
import android.widget.Toast;
import android.widget.AdapterView.OnItemClickListener;

public class CPCL3Menu extends ListActivity
{	
	final static String[] arr = 
	{
		"Barcode",
		"CITIZEN SYSTEM",
		"Image Test",
		"Font Type Test",
		"MULTILINE",
		"Status Check",
		"COUNTRY",
		"Print Android Font",
		"Print Multilingual",
		"Print Results"
	};
	
	private String strCount;
	private Spinner paperSpinner;

	@Override
	protected void onDestroy()
	{
		super.onDestroy();
		Log.w("OnDestroy()", "Activity Destroyed.");
	}
	
	/** Called when the activity is first created. */
	@Override
	public void onCreate(Bundle savedInstanceState)
	{
		super.onCreate(savedInstanceState);
		setContentView(R.layout.label_sample_menu);
		
		ArrayAdapter<CharSequence> paperAdapter = ArrayAdapter.createFromResource(this, R.array.label_paper, android.R.layout.simple_spinner_item);
        paperAdapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
        paperSpinner = (Spinner) findViewById(R.id.paper_spinner);
        paperSpinner.setAdapter(paperAdapter);
        paperSpinner.setSelection(2);

		setListAdapter(new ArrayAdapter<String>(this, android.R.layout.simple_list_item_1 , arr));
		getListView().setOnItemClickListener(new OnItemClickListener()
		{
			@Override
			public void onItemClick(AdapterView<?> arg0, View arg1, int arg2, long arg3)
			{
				dialog(arg2);
			}
		});
	}
	
	// Dialog
	private void dialog(int arg1)
	{
		final int arg2 = arg1; 
		final LinearLayout linear = (LinearLayout)
			View.inflate(CPCL3Menu.this, R.layout.input_popup, null);
		
		final EditText number = (EditText)linear.findViewById(R.id.EditTextPopup);
		if(strCount == null)
			strCount = "1";
		number.setText(strCount);
		
		new AlertDialog.Builder(CPCL3Menu.this)
		.setTitle("Test Count.")
		.setIcon(R.drawable.icon)
		.setView(linear)
		.setPositiveButton("OK", new DialogInterface.OnClickListener() {
			public void onClick(DialogInterface dialog, int whichButton) 
			{
				try
				{
					CPCLSample3 sample = new CPCLSample3();
					strCount = number.getText().toString();
					int count = Integer.parseInt(strCount);
					int results = 0;
					Log.d("NUM",count+"");

					int paperType = paperSpinner.getSelectedItemPosition();
					// R.array.label_paper [GAP, BM, CONT]
					switch(paperType)
					{
						case 0:
							sample.selectGapPaper();
							break;
						case 1:
							sample.selectBlackMarkPaper();
							break;
						case 2:
							sample.selectContinuousPaper();
							break;
						default:
					}

//					String temp = sample.statusCheck();
//					Toast toast = Toast.makeText(CPCL3Menu.this, temp, Toast.LENGTH_LONG);
//					toast.show();

					switch(arg2)
					{
						case 0:
							results = sample.barcode3(count);
							break;
						case 1:
							results = sample.Profile3(count);
							break;
						case 2:
							results = sample.image3(count);
							break;
						case 3:
							results = sample.fontTypeTest(count);
							break;
						case 4:
							results = sample.multiLineTest(count);
							break;
						case 5:
							results = sample.statusCheck();
							break;
						case 6:
							results = sample.countryTest(count);
							break;
						case 7:
							results = sample.printAndroidFont(count);
							break;
						case 8:
							results = sample.printMultilingualFont(count);
							break;	
						case 9:
							results = sample.printResults(count);
							break;	
						default:
					}

					String statusMsg;
					
					if(results == CPCLConst.CMP_STS_CPCL_NORMAL)
						statusMsg = new String("Normal");
					else
					{
						statusMsg = new String();
						if((results & CPCLConst.CMP_STS_CPCL_COVER_OPEN) > 0)
							statusMsg = statusMsg + "Cover Open\r\n";
						if((results & CPCLConst.CMP_STS_CPCL_PAPER_EMPTY) > 0)
							statusMsg = statusMsg + "Paper Empty\r\n";
						if((results & CPCLConst.CMP_STS_CPCL_BATTERY_LOW) > 0)
							statusMsg = statusMsg + "Battery Low\r\n";
						if((results & CPCLConst.CMP_STS_CPCL_PRINTEROFF) > 0)
							statusMsg = statusMsg + "Printer Power OFF\r\n";
						if((results & CPCLConst.CMP_STS_CPCL_TIMEOUT) > 0)
							statusMsg = statusMsg + "Timeout error";
					}
					Toast toast = Toast.makeText(CPCL3Menu.this, statusMsg, Toast.LENGTH_SHORT);
					toast.show();
				}
				catch(NumberFormatException e)
				{
					Log.e("NumberFormatException","Invalid Input Number.",e);
				}
				catch(Exception e)
				{
					Log.e("Exception","Unknown Exception.",e);	
				}
			}
		})
		.setNegativeButton("Cancel", new DialogInterface.OnClickListener() {
			public void onClick(DialogInterface dialog, int whichButton) 
			{
				Log.d("Cancel", "Print Canceled.");
			}
		})
		.show();
	}
}