package com.citizen.app.assist;

import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;

import android.graphics.Typeface;

import com.citizen.jpos.command.ESCPOS;
import com.citizen.jpos.command.ESCPOSConst;
import com.citizen.jpos.printer.ESCPOSPrinter;
import com.citizen.jpos.printer.CMPPrint;

public class ESCPSample4
{
	private ESCPOSPrinter posPtr;
	// 0x1B
	private final char ESC = ESCPOS.ESC;
	
	public ESCPSample4()
	{
		posPtr = new ESCPOSPrinter();
	}
	
    public int sample1() throws UnsupportedEncodingException
    {
    	int sts;
    	
		sts = posPtr.printerCheck();
		if(sts != ESCPOSConst.CMP_SUCCESS) return sts;

		sts = posPtr.status();
		if(sts != ESCPOSConst.CMP_SUCCESS) return sts;

    	Calendar calendar = Calendar.getInstance();
		Date date = calendar.getTime();
		String today =(new SimpleDateFormat("yyyy-MM-dd-HH:mm:ss").format(date));

		posPtr.printNormal(ESC+"|cA"+ESC+"|2CReceipt\r\n\r\n\r\n");
	    posPtr.printNormal(ESC+"|rATEL (123)-456-7890\n\n\n");
	    posPtr.printNormal(ESC+"|cAThank you for coming to our shop!\n");
	    posPtr.printNormal(ESC+"|cA" + today + "\n\n");
	    posPtr.printNormal("Chicken                                                       $10.00\n");
	    posPtr.printNormal("Hamburger                                                     $20.00\n");
	    posPtr.printNormal("Pizza                                                         $30.00\n");
	    posPtr.printNormal("Lemons                                                        $40.00\n");
	    posPtr.printNormal("Drink                                                         $50.00\n");
	    posPtr.printNormal("Excluded tax                                                 $150.00\n");
	    posPtr.printNormal(ESC+"|uCTax(5%)                                                        $7.50\n");
	    posPtr.printNormal(ESC+"|bC"+ESC+"|2CTotal                      $157.50\n\n");
	    posPtr.printNormal("Payment                                                      $200.00\n");
	    posPtr.printNormal("Change                                                        $42.50\n\n");
	    posPtr.printBarCode("{Babc456789012", CMPPrint.CMP_BCS_Code128, 40, 832, CMPPrint.CMP_ALIGNMENT_CENTER, CMPPrint.CMP_HRI_TEXT_BELOW); // Print Barcode
		posPtr.lineFeed(2);

        return ESCPOSConst.CMP_SUCCESS;
    }
    
    public int sample2() throws UnsupportedEncodingException
    {
    	int sts;
    	
		sts = posPtr.printerCheck();
		if(sts != ESCPOSConst.CMP_SUCCESS) return sts;

		sts = posPtr.status();
		if(sts != ESCPOSConst.CMP_SUCCESS) return sts;

	    posPtr.printText("Receipt\r\n\r\n\r\n", CMPPrint.CMP_ALIGNMENT_CENTER, CMPPrint.CMP_FNT_DEFAULT, CMPPrint.CMP_TXT_2WIDTH);
	    posPtr.printText("TEL (123)-456-7890\r\n", CMPPrint.CMP_ALIGNMENT_RIGHT, CMPPrint.CMP_FNT_DEFAULT, CMPPrint.CMP_TXT_1WIDTH);
	    posPtr.printText("Thank you for coming to our shop!\r\n", CMPPrint.CMP_ALIGNMENT_CENTER, CMPPrint.CMP_FNT_DEFAULT, CMPPrint.CMP_TXT_1WIDTH);
	    posPtr.printText("Chicken                                                       $10.00\r\n", CMPPrint.CMP_ALIGNMENT_LEFT, CMPPrint.CMP_FNT_DEFAULT, CMPPrint.CMP_TXT_1WIDTH);
	    posPtr.printText("Hamburger                                                     $20.00\r\n", CMPPrint.CMP_ALIGNMENT_LEFT, CMPPrint.CMP_FNT_DEFAULT, CMPPrint.CMP_TXT_1WIDTH);
	    posPtr.printText("Pizza                                                         $30.00\r\n", CMPPrint.CMP_ALIGNMENT_LEFT, CMPPrint.CMP_FNT_DEFAULT, CMPPrint.CMP_TXT_1WIDTH);
	    posPtr.printText("Lemons                                                        $40.00\r\n", CMPPrint.CMP_ALIGNMENT_LEFT, CMPPrint.CMP_FNT_DEFAULT, CMPPrint.CMP_TXT_1WIDTH);
	    posPtr.printText("Drink                                                         $50.00\r\n\r\n", CMPPrint.CMP_ALIGNMENT_LEFT, CMPPrint.CMP_FNT_DEFAULT, CMPPrint.CMP_TXT_1WIDTH);
	    posPtr.printText("Excluded tax                                                 $150.00\r\n", CMPPrint.CMP_ALIGNMENT_LEFT, CMPPrint.CMP_FNT_DEFAULT, CMPPrint.CMP_TXT_1WIDTH);
	    posPtr.printText("Tax(5%)                                                        $7.50\r\n", CMPPrint.CMP_ALIGNMENT_LEFT, CMPPrint.CMP_FNT_UNDERLINE, CMPPrint.CMP_TXT_1WIDTH);
	    posPtr.printText("Total                      $157.50\r\n\r\n", CMPPrint.CMP_ALIGNMENT_LEFT, CMPPrint.CMP_FNT_DEFAULT, CMPPrint.CMP_TXT_2WIDTH);
	    posPtr.printText("Payment                                                      $200.00\r\n", CMPPrint.CMP_ALIGNMENT_LEFT, CMPPrint.CMP_FNT_DEFAULT, CMPPrint.CMP_TXT_1WIDTH);
	    posPtr.printText("Change                                                        $42.50\r\n\r\n", CMPPrint.CMP_ALIGNMENT_LEFT, CMPPrint.CMP_FNT_DEFAULT, CMPPrint.CMP_TXT_1WIDTH);
	    posPtr.printBarCode("0123456789", CMPPrint.CMP_BCS_Code39, 40, 832, CMPPrint.CMP_ALIGNMENT_CENTER, CMPPrint.CMP_HRI_TEXT_BELOW);
		posPtr.lineFeed(2);
		
        return ESCPOSConst.CMP_SUCCESS;
    }
    
    public int imageTest() throws IOException
    {
    	int sts;
    	
		sts = posPtr.printerCheck();
		if(sts != ESCPOSConst.CMP_SUCCESS) return sts;

		sts = posPtr.status();
		if(sts != ESCPOSConst.CMP_SUCCESS) return sts;

		posPtr.printBitmap("//sdcard//temp//citizen//car_s.jpg", CMPPrint.CMP_ALIGNMENT_CENTER);
    	posPtr.printBitmap("//sdcard//temp//citizen//danmark_windmill.jpg", CMPPrint.CMP_ALIGNMENT_LEFT);
    	posPtr.printBitmap("//sdcard//temp//citizen//denmark_flag.jpg", CMPPrint.CMP_ALIGNMENT_RIGHT);
		posPtr.lineFeed(2);

        return ESCPOSConst.CMP_SUCCESS;
    }
    
    public int westernLatinCharTest() throws UnsupportedEncodingException
    {    	
    	int sts;
    	
		sts = posPtr.printerCheck();
		if(sts != ESCPOSConst.CMP_SUCCESS) return sts;

		sts = posPtr.status();
		if(sts != ESCPOSConst.CMP_SUCCESS) return sts;

    	final char [] diff = {0x23,0x24,0x40,0x5B,0x5C,0x5D,0x5E,0x6C,0x7B,0x7C,0x7D,0x7E,
   			 0xA4,0xA6,0xA8,0xB4,0xB8,0xBC,0xBD,0xBE};
    	String ad = new String(diff);
    	posPtr.printText(ad+"\r\n\r\n", CMPPrint.CMP_ALIGNMENT_LEFT, CMPPrint.CMP_FNT_DEFAULT, CMPPrint.CMP_TXT_1WIDTH);    		
		posPtr.lineFeed(2);

        return ESCPOSConst.CMP_SUCCESS;
    }
    
    public int barcode2DTest() throws UnsupportedEncodingException
    {
    	int sts;
    	
		sts = posPtr.printerCheck();
		if(sts != ESCPOSConst.CMP_SUCCESS) return sts;

		sts = posPtr.status();
		if(sts != ESCPOSConst.CMP_SUCCESS) return sts;

		String data = "ABCDEFGHIJKLMN";
    	posPtr.printString("PDF417 1\r\n");
    	posPtr.printPDF417(data, data.length(), 2, 20, ESCPOSConst.CMP_ALIGNMENT_LEFT);
    	posPtr.printString("PDF417 2\r\n");
    	posPtr.printPDF417(data, data.length(), 10, 30, ESCPOSConst.CMP_ALIGNMENT_LEFT);    	
    	posPtr.printString("QR 1\r\n");
    	posPtr.printQRCode(data, data.length(), 3, ESCPOSConst.CMP_QRCODE_EC_LEVEL_L, ESCPOSConst.CMP_ALIGNMENT_CENTER);
    	posPtr.printString("QR 2\r\n");
    	posPtr.printQRCode(data, data.length(), 11, ESCPOSConst.CMP_QRCODE_EC_LEVEL_L, ESCPOSConst.CMP_ALIGNMENT_CENTER);
		posPtr.lineFeed(2);

		return ESCPOSConst.CMP_SUCCESS;
    }

    public int printAndroidFont() throws UnsupportedEncodingException
	{
    	int nLineWidth = 832;
    	String data = "Receipt";
    	int sts;
    	
		sts = posPtr.printerCheck();
		if(sts != ESCPOSConst.CMP_SUCCESS) return sts;

		sts = posPtr.status();
		if(sts != ESCPOSConst.CMP_SUCCESS) return sts;

    	try
		{
			posPtr.printAndroidFont(data, nLineWidth, 100, ESCPOSConst.CMP_ALIGNMENT_CENTER);
			posPtr.lineFeed(2);
			posPtr.printAndroidFont("Left Alignment", nLineWidth, 24, ESCPOSConst.CMP_ALIGNMENT_LEFT);
			posPtr.printAndroidFont("Center Alignment", nLineWidth, 24, ESCPOSConst.CMP_ALIGNMENT_CENTER);
			posPtr.printAndroidFont("Right Alignment", nLineWidth, 24, ESCPOSConst.CMP_ALIGNMENT_RIGHT);

			posPtr.lineFeed(2);
			posPtr.printAndroidFont(Typeface.SANS_SERIF, "SANS_SERIF : 1234iwIW", nLineWidth, 24, ESCPOSConst.CMP_ALIGNMENT_LEFT);
			posPtr.printAndroidFont(Typeface.SERIF, "SERIF : 1234iwIW", nLineWidth, 24, ESCPOSConst.CMP_ALIGNMENT_LEFT);
			posPtr.printAndroidFont(Typeface.MONOSPACE, "MONOSPACE : 1234iwIW", nLineWidth, 24, ESCPOSConst.CMP_ALIGNMENT_LEFT);

			posPtr.lineFeed(2);
			posPtr.printAndroidFont(Typeface.SANS_SERIF, "SANS : 1234iwIW", nLineWidth, 24, ESCPOSConst.CMP_ALIGNMENT_LEFT);
			posPtr.printAndroidFont(Typeface.SANS_SERIF, true, "SANS BOLD : 1234iwIW", nLineWidth, 24, ESCPOSConst.CMP_ALIGNMENT_LEFT);
			posPtr.printAndroidFont(Typeface.SANS_SERIF, true, false, "SANS BOLD : 1234iwIW", nLineWidth, 24, ESCPOSConst.CMP_ALIGNMENT_LEFT);
			posPtr.printAndroidFont(Typeface.SANS_SERIF, false, true, "SANS ITALIC : 1234iwIW", nLineWidth, 24, ESCPOSConst.CMP_ALIGNMENT_LEFT);
			posPtr.printAndroidFont(Typeface.SANS_SERIF, true, true, "SANS BOLD ITALIC : 1234iwIW", nLineWidth, 24, ESCPOSConst.CMP_ALIGNMENT_LEFT);
			posPtr.printAndroidFont(Typeface.SANS_SERIF, true, true, true, "SANS B/I/U : 1234iwIW", nLineWidth, 24, ESCPOSConst.CMP_ALIGNMENT_LEFT);

			posPtr.lineFeed(2);
			posPtr.printAndroidFont(Typeface.SERIF, "SERIF : 1234iwIW", nLineWidth, 24, ESCPOSConst.CMP_ALIGNMENT_LEFT);
			posPtr.printAndroidFont(Typeface.SERIF, true, "SERIF BOLD : 1234iwIW", nLineWidth, 24, ESCPOSConst.CMP_ALIGNMENT_LEFT);
			posPtr.printAndroidFont(Typeface.SERIF, true, false, "SERIF BOLD : 1234iwIW", nLineWidth, 24, ESCPOSConst.CMP_ALIGNMENT_LEFT);
			posPtr.printAndroidFont(Typeface.SERIF, false, true, "SERIF ITALIC : 1234iwIW", nLineWidth, 24, ESCPOSConst.CMP_ALIGNMENT_LEFT);
			posPtr.printAndroidFont(Typeface.SERIF, true, true, "SERIF BOLD ITALIC : 1234iwIW", nLineWidth, 24, ESCPOSConst.CMP_ALIGNMENT_LEFT);
			posPtr.printAndroidFont(Typeface.SERIF, true, true, true, "SERIF B/I/U : 1234iwIW", nLineWidth, 24, ESCPOSConst.CMP_ALIGNMENT_LEFT);

			posPtr.lineFeed(2);
			posPtr.printAndroidFont(Typeface.MONOSPACE, "MONOSPACE : 1234iwIW", nLineWidth, 24, ESCPOSConst.CMP_ALIGNMENT_LEFT);
			posPtr.printAndroidFont(Typeface.MONOSPACE, true, "MONO BOLD : 1234iwIW", nLineWidth, 24, ESCPOSConst.CMP_ALIGNMENT_LEFT);
			posPtr.printAndroidFont(Typeface.MONOSPACE, true, false, "MONO BOLD : 1234iwIW", nLineWidth, 24, ESCPOSConst.CMP_ALIGNMENT_LEFT);
			posPtr.printAndroidFont(Typeface.MONOSPACE, false, true, "MONO ITALIC : 1234iwIW", nLineWidth, 24, ESCPOSConst.CMP_ALIGNMENT_LEFT);
			posPtr.printAndroidFont(Typeface.MONOSPACE, true, true, "MONO BOLD ITALIC: 1234iwIW", nLineWidth, 24, ESCPOSConst.CMP_ALIGNMENT_LEFT);
			posPtr.printAndroidFont(Typeface.MONOSPACE, true, true, true, "MONO B/I/U: 1234iwIW", nLineWidth, 24, ESCPOSConst.CMP_ALIGNMENT_LEFT);

			posPtr.lineFeed(4);
		}
		catch (IOException e)
		{
			e.printStackTrace();
		}

		return ESCPOSConst.CMP_SUCCESS;
	}

    public int printMultilingualFont() throws UnsupportedEncodingException
	{
    	int nLineWidth = 832;
    	String Koreandata = "영수증";
    	String Turkishdata = "Turkish(İ,Ş,Ğ)";
    	String Russiandata = "Получение";
    	String Arabicdata = "الإيصال";
    	String Greekdata = "Παραλαβή";
    	String Japanesedata = "領収書";
    	String GB2312data = "收据";
    	String BIG5data = "收據";

    	int sts;
    	
		sts = posPtr.printerCheck();
		if(sts != ESCPOSConst.CMP_SUCCESS) return sts;

		sts = posPtr.status();
		if(sts != ESCPOSConst.CMP_SUCCESS) return sts;

    	try
		{
			posPtr.printAndroidFont("Korean Font", nLineWidth, 24, ESCPOSConst.CMP_ALIGNMENT_LEFT);
    		// Korean 100-dot size font in android device.
        	posPtr.printAndroidFont(Koreandata, nLineWidth, 100, ESCPOSConst.CMP_ALIGNMENT_CENTER);

			posPtr.printAndroidFont("Turkish Font", nLineWidth, 24, ESCPOSConst.CMP_ALIGNMENT_LEFT);
    		// Turkish 50-dot size font in android device.
        	posPtr.printAndroidFont(Turkishdata, nLineWidth, 50, ESCPOSConst.CMP_ALIGNMENT_CENTER);

			posPtr.printAndroidFont("Russian Font", nLineWidth, 24, ESCPOSConst.CMP_ALIGNMENT_LEFT);
    		// Russian 60-dot size font in android device.
        	posPtr.printAndroidFont(Russiandata, nLineWidth, 60, ESCPOSConst.CMP_ALIGNMENT_CENTER);

			posPtr.printAndroidFont("Arabic Font", nLineWidth, 24, ESCPOSConst.CMP_ALIGNMENT_LEFT);
    		// Arabic 100-dot size font in android device.
        	posPtr.printAndroidFont(Arabicdata, nLineWidth, 100, ESCPOSConst.CMP_ALIGNMENT_CENTER);

			posPtr.printAndroidFont("Greek Font", nLineWidth, 24, ESCPOSConst.CMP_ALIGNMENT_LEFT);
    		// Greek 60-dot size font in android device.
        	posPtr.printAndroidFont(Greekdata, nLineWidth, 60, ESCPOSConst.CMP_ALIGNMENT_CENTER);

			posPtr.printAndroidFont("Japanese Font", nLineWidth, 24, ESCPOSConst.CMP_ALIGNMENT_LEFT);
        	// Japanese 100-dot size font in android device.
        	posPtr.printAndroidFont(Japanesedata, nLineWidth, 100, ESCPOSConst.CMP_ALIGNMENT_CENTER);

			posPtr.printAndroidFont("GB2312 Font", nLineWidth, 24, ESCPOSConst.CMP_ALIGNMENT_LEFT);
    		// GB2312 100-dot size font in android device.
        	posPtr.printAndroidFont(GB2312data, nLineWidth, 100, ESCPOSConst.CMP_ALIGNMENT_CENTER);

			posPtr.printAndroidFont("BIG5 Font", nLineWidth, 24, ESCPOSConst.CMP_ALIGNMENT_LEFT);
    		// BIG5 100-dot size font in android device.
        	posPtr.printAndroidFont(BIG5data, nLineWidth, 100, ESCPOSConst.CMP_ALIGNMENT_CENTER);

			posPtr.lineFeed(4);
		}
		catch (IOException e)
		{
			e.printStackTrace();
		}

		return ESCPOSConst.CMP_SUCCESS;
	}

	public int printingResults() throws UnsupportedEncodingException
    {
		int sts;
		Calendar calendar = Calendar.getInstance();
		Date date = calendar.getTime();
		String today =(new SimpleDateFormat("yyyy-MM-dd-HH:mm:ss").format(date));

		sts = posPtr.printerCheck(5000, true);
		if(sts != ESCPOSConst.CMP_SUCCESS) return ESCPOSConst.CMP_FAIL;

		sts = posPtr.status();
		if(sts != ESCPOSConst.CMP_SUCCESS) return sts;

		posPtr.printNormal(ESC+"|cA"+ESC+"|2CReceipt\r\n\r\n\r\n");
	    posPtr.printNormal(ESC+"|rATEL (123)-456-7890\n\n\n");
	    posPtr.printNormal(ESC+"|cAThank you for coming to our shop!\n");
	    posPtr.printNormal(ESC+"|cA" + today + "\n\n");
	    posPtr.printNormal("Chicken                                                       $10.00\n");
	    posPtr.printNormal("Hamburger                                                     $20.00\n");
	    posPtr.printNormal("Pizza                                                         $30.00\n");
	    posPtr.printNormal("Lemons                                                        $40.00\n");
	    posPtr.printNormal("Drink                                                         $50.00\n");
	    posPtr.printNormal("Excluded tax                                                 $150.00\n");
	    posPtr.printNormal(ESC+"|uCTax(5%)                                                        $7.50\n");
	    posPtr.printNormal(ESC+"|bC"+ESC+"|2CTotal                      $157.50\n\n");
	    posPtr.printNormal("Payment                                                      $200.00\n");
	    posPtr.printNormal("Change                                                        $42.50\n\n");
	    posPtr.printBarCode("{Babc456789012", CMPPrint.CMP_BCS_Code128, 40, 832, CMPPrint.CMP_ALIGNMENT_CENTER, CMPPrint.CMP_HRI_TEXT_BELOW); // Print Barcode
		posPtr.lineFeed(2);
        
		sts = posPtr.printerResults();
        return sts;
    }

	public int printFontB() throws UnsupportedEncodingException
    {
		posPtr = new ESCPOSPrinter("Shift_JIS");

    	int sts;
    	
		sts = posPtr.printerCheck();
		if(sts != ESCPOSConst.CMP_SUCCESS) return sts;

		sts = posPtr.status();
		if(sts != ESCPOSConst.CMP_SUCCESS) return sts;

		posPtr.printNormal(ESC+"|N");                               // Normal（標準）

        posPtr.printNormal( "printNormal あいうえお, CMP_ALIGNMENT_CENTER, CMP_FNT_FONTB, CMP_TXT_1WIDTH \n" );
        posPtr.printText( "printText あいうえお\n\n", ESCPOSConst.CMP_ALIGNMENT_CENTER, ESCPOSConst.CMP_FNT_FONTB, ESCPOSConst.CMP_TXT_1WIDTH );

        posPtr.printNormal( "printNormal あいうえお, CMP_ALIGNMENT_CENTER, CMP_FNT_FONTB, CMP_TXT_2WIDTH \n" );
        posPtr.printText( "printText あいうえお\n\n", ESCPOSConst.CMP_ALIGNMENT_CENTER, ESCPOSConst.CMP_FNT_FONTB, ESCPOSConst.CMP_TXT_2WIDTH );

        posPtr.printNormal( "printNormal あいうえお, CMP_ALIGNMENT_CENTER, CMP_FNT_FONTB, CMP_TXT_3WIDTH \n" );
        posPtr.printText( "printText あいうえお\n\n", ESCPOSConst.CMP_ALIGNMENT_CENTER, ESCPOSConst.CMP_FNT_FONTB, ESCPOSConst.CMP_TXT_3WIDTH );

        posPtr.printNormal( "printNormal あいうえお, CMP_ALIGNMENT_CENTER, CMP_FNT_FONTB, CMP_TXT_3HEIGHT \n" );
        posPtr.printText( "printText あいうえお\n\n", ESCPOSConst.CMP_ALIGNMENT_CENTER, ESCPOSConst.CMP_FNT_FONTB, ESCPOSConst.CMP_TXT_3HEIGHT );

        posPtr.printNormal( "printNormal あいうえお, CMP_ALIGNMENT_RIGHT, CMP_FNT_BOLD, CMP_TXT_8HEIGHT \n" );
        posPtr.printText( "printText あいうえお\n\n", ESCPOSConst.CMP_ALIGNMENT_RIGHT, ESCPOSConst.CMP_FNT_BOLD, ESCPOSConst.CMP_TXT_8HEIGHT );

        posPtr.printNormal( "printNormal あいうえお, CMP_ALIGNMENT_CENTER, CMP_FNT_UNDERLINE, CMP_TXT_4WIDTH \n" );
        posPtr.printText( "printText あいうえお\n\n", ESCPOSConst.CMP_ALIGNMENT_CENTER, ESCPOSConst.CMP_FNT_UNDERLINE, ESCPOSConst.CMP_TXT_4WIDTH );

        posPtr.printNormal( "printNormal あいうえお, CMP_ALIGNMENT_RIGHT, CMP_FNT_DEFAULT, CMP_TXT_2HEIGHT \n" );
        posPtr.printText( "printText あいうえお\n\n", ESCPOSConst.CMP_ALIGNMENT_RIGHT, ESCPOSConst.CMP_FNT_DEFAULT, ESCPOSConst.CMP_TXT_2HEIGHT );

        posPtr.printNormal( "printNormal あいうえお\n" );

        posPtr.lineFeed(4);
    
		return ESCPOSConst.CMP_SUCCESS;
    }

	public int printerStatus() throws UnsupportedEncodingException
    {
		int sts;

		sts = posPtr.printerCheck();
		if(sts != ESCPOSConst.CMP_SUCCESS) return ESCPOSConst.CMP_FAIL;

		sts = posPtr.status();
		if(sts != ESCPOSConst.CMP_SUCCESS) return sts;

		return sts;
    }

}
