package com.citizen.app.escpos;

import java.io.IOException;

import com.citizen.app.assist.ESCPSample3;
import com.citizen.jpos.command.ESCPOSConst;
import com.citizen.app.assist.AlertView;

import android.app.AlertDialog;
import android.app.ListActivity;
import android.content.Context;
import android.content.DialogInterface;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.EditText;
import android.widget.LinearLayout;
import android.widget.Toast;
import android.widget.AdapterView.OnItemClickListener;

public class ESCP3Menu extends ListActivity
{
	private Context context;
	// Menu
	final static String[] arr = 
	{
		"Sample 1",
		"Sample 2",
		"Image Test",
		"Character Test",
		"2D Barcode Test",
		"Print Android Font",
		"Print Multilingual",
		"Print Results",
		"FontB Test",
		"Printer status"
	};
	
	private String strCount;

	@Override
	protected void onDestroy()
	{
		super.onDestroy();
	}
	
	/** Called when the activity is first created. */
	@Override
	public void onCreate(Bundle savedInstanceState)
	{
		super.onCreate(savedInstanceState);
		context = this;

		setListAdapter(new ArrayAdapter<String>(this, android.R.layout.simple_list_item_1 , arr));
		getListView().setOnItemClickListener(new OnItemClickListener()
		{
			@Override
			public void onItemClick(AdapterView<?> arg0, View arg1, int arg2, long arg3)
			{
				dialog(arg2);
			}
		});
	}
	
	// Dialog
	private void dialog(int arg1)
	{
		final int arg2 = arg1; 
		final LinearLayout linear = (LinearLayout)
			View.inflate(ESCP3Menu.this, R.layout.input_popup, null);
		
		final EditText number = (EditText)linear.findViewById(R.id.EditTextPopup);
		if(strCount == null)
			strCount = "1";
		number.setText(strCount);
		
		new AlertDialog.Builder(ESCP3Menu.this)
		.setTitle("Test Count.")
		.setIcon(R.drawable.icon)
		.setView(linear)
		.setPositiveButton("OK", new DialogInterface.OnClickListener() {
			public void onClick(DialogInterface dialog, int whichButton) 
			{
				try
				{
					ESCPSample3 sample = new ESCPSample3();					
					strCount = number.getText().toString();
					int count = Integer.parseInt(strCount);
					int results = 0;
					Toast tst = null;
					Log.d("NUM",count+"");
					for(int i=0;i<count;i++)
					{
						switch(arg2)
						{
							case 0:
								results = sample.sample1();
								break;
							case 1:
								results = sample.sample2();
								break;
							case 2:
								results = sample.imageTest();
								break;
							case 3:
								results = sample.westernLatinCharTest();
								break;
							case 4:
								results = sample.barcode2DTest();
								break;
							case 5:
								results = sample.printAndroidFont();
								break;	
							case 6:
								results = sample.printMultilingualFont();
								break;	
							case 7:
								results = sample.printingResults();
								break;
							case 8:
								results = sample.printFontB();
								break;	
							case 9:
								results = sample.printerStatus();
								break;
							default:
								break;
						}

						String statusMsg;
						
						if(results == ESCPOSConst.CMP_STS_NORMAL)
						{
							statusMsg = new String("Printing success");
							Toast toast = Toast.makeText(ESCP3Menu.this, statusMsg, Toast.LENGTH_SHORT);
							toast.show();
						} else {
							statusMsg = new String();
							if((results & ESCPOSConst.CMP_STS_COVER_OPEN) > 0)
								statusMsg = statusMsg + "Cover Open\r\n";
							if((results & ESCPOSConst.CMP_STS_PAPER_EMPTY) > 0)
								statusMsg = statusMsg + "Paper Empty\r\n";
							if((results & ESCPOSConst.CMP_STS_BATTERY_LOW) > 0)
								statusMsg = statusMsg + "Battery Low\r\n";
							if((results & ESCPOSConst.CMP_STS_PRINTEROFF) > 0)
								statusMsg = statusMsg + "Printer Power OFF\r\nReconnect and print\r\n";
							if((results & ESCPOSConst.CMP_STS_TIMEOUT) > 0)
								statusMsg = statusMsg + "Timeout error";
							AlertView.showAlert(statusMsg, context);
						}
					}
				}
				catch(NumberFormatException e)
				{
					Log.d("NumberFormatException","Invalid Input Nubmer.");
				}
				catch(IOException e)
				{
					Log.d("IO Exception", "IO Error");	
				}
			}
		})
		.setNegativeButton("Cancel", new DialogInterface.OnClickListener() {
			public void onClick(DialogInterface dialog, int whichButton) 
			{
				Log.d("Cancel", "Cancel Button Clicked.");
			}
		})
		.show();
	}
}