package com.citizen.app.zpl;

import java.io.IOException;
import java.util.ArrayList;

import com.citizen.app.assist.ZPLSample2;
import com.citizen.app.zpl.R;
import com.citizen.jpos.command.ZPLConst;

import android.app.AlertDialog;
import android.app.ListActivity;
import android.content.Context;
import android.content.DialogInterface;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.EditText;
import android.widget.LinearLayout;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.Spinner;
import android.widget.Toast;

public class ZPL2Menu extends ListActivity
{
	private final String TAG = "ZPL2Menu";
    
	// Menu
	final static String[] arr = 
	{
		"Text",								
		"Geometry",							
		"Image",							
		"1D Barcode",						
		"2D Barcode",						
		"Download Graphic",
		"Print Graphic",
		"Delete Graphic"
	};
	
	private String strCount;
	private Spinner paperSpinner;
	private char paperType = ZPLConst.CMP_SENSE_GAP;
	
	ZPLSample2 sample;
	
	@Override
	protected void onDestroy()
	{
		super.onDestroy();
		Log.d(TAG, "OnDestroy");
	}
	
	/** Called when the activity is first created. */
	@Override
	public void onCreate(Bundle savedInstanceState)
	{
		super.onCreate(savedInstanceState);
		setContentView(R.layout.sample_menu);
		
		sample = new ZPLSample2();
		
		ArrayAdapter<CharSequence> paperAdapter = ArrayAdapter.createFromResource(this, R.array.label_paper, android.R.layout.simple_spinner_item);
        paperAdapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
        paperSpinner = (Spinner) findViewById(R.id.SpinnerMediaType);
        paperSpinner.setAdapter(paperAdapter);
        paperSpinner.setSelection(0);
        
        paperSpinner.setOnItemSelectedListener(new AdapterView.OnItemSelectedListener() {

			@Override
			public void onItemSelected(AdapterView<?> parent, View view,
					int position, long id) {
				// TODO Auto-generated method stub
				switch(position)
                {
                    case 0 : paperType = ZPLConst.CMP_SENSE_GAP; break;
                    case 1 : paperType = ZPLConst.CMP_SENSE_BLACKMARK; break;
                    case 2 : paperType = ZPLConst.CMP_SENSE_CONTINUOUS; break;
                }
			}

			@Override
			public void onNothingSelected(AdapterView<?> parent) {
				// TODO Auto-generated method stub
				
			}
		});
		
		setListAdapter(new ArrayAdapter<String>(this, android.R.layout.simple_list_item_1 , arr));
		getListView().setOnItemClickListener(new OnItemClickListener()
		{
			@Override
			public void onItemClick(AdapterView<?> arg0, View arg1, int arg2, long arg3)
			{
				dialog(arg2);
			}
		});
	}
	
	// Dialog
	private void dialog(int arg1)
	{
		final int arg2 = arg1; 
		final LinearLayout linear = (LinearLayout)
			View.inflate(ZPL2Menu.this, R.layout.input_popup, null);
		
		final EditText number = (EditText)linear.findViewById(R.id.EditTextPopup);
		if(strCount == null)
			strCount = "1";
		number.setText(strCount);
		
		if(arg2 == 5 || arg2 == 6 || arg2 == 7)
		{
			try {
				if(arg2 == 5)
				{
					sample.downloadImage();
					Toast.makeText(getApplicationContext(), "Download Image", Toast.LENGTH_SHORT).show();
				}
				else if(arg2 == 6)
				{
					sample.printSavedImage(paperType);
				}
				else
				{
					sample.deleteSavedImage();
					Toast.makeText(getApplicationContext(), "Delete Image", Toast.LENGTH_SHORT).show();
				}
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			
			return;
		}
		
		new AlertDialog.Builder(ZPL2Menu.this)
		.setTitle("Test Count.")
		.setIcon(R.drawable.icon)
		.setView(linear)
		.setPositiveButton("OK", new DialogInterface.OnClickListener() {
			public void onClick(DialogInterface dialog, int whichButton) 
			{
				try
				{
					strCount = number.getText().toString();
					int count = Integer.parseInt(strCount);

					switch(arg2)
					{
					case 0:
						sample.textTest(count, paperType);
						break;
					case 1:
						sample.geometryTest(count, paperType);
						break;
					case 2:
						sample.imageTest(count, paperType);
						break;
					case 3:
						sample.barcode1DTest(count, paperType);
						break;
					case 4:
						sample.barcode2DTest(count, paperType);
						break;
					default:
					}

				}
				catch(NumberFormatException e)
				{
					Log.e(TAG, "Invalid Input Nubmer. : "+e.getMessage(), e);
				}
				catch(IOException e)
				{
					Log.e(TAG, "IO Error. : "+e.getMessage(), e);	
				}
			}
		})
		.setNegativeButton("Cancel", new DialogInterface.OnClickListener() {
			public void onClick(DialogInterface dialog, int whichButton) 
			{
				Log.d(TAG, "Cancel Button Clicked.");
			}
		})
		.show();
	}
}