package com.citizen.escp.status.app.assist;

import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;

import android.content.Context;
import android.graphics.Typeface;
import android.util.Log;
import android.widget.Toast;

import com.citizen.escp.status.app.escpos.ESCP2Menu;
import com.citizen.jpos.command.CPCLConst;
import com.citizen.jpos.command.ESCPOS;
import com.citizen.jpos.command.ESCPOSConst;
import com.citizen.jpos.printer.ESCPOSPrinter;
import com.citizen.jpos.printer.CMPPrint;

public class ESCPSample2
{
	private ESCPOSPrinter posPtr;
	private final char ESC = ESCPOS.ESC;
	private final char LF = ESCPOS.LF;
	
	
	public ESCPSample2()
	{
		posPtr = new ESCPOSPrinter("Shift_JIS");
	}
	
	public int printerStatus() throws UnsupportedEncodingException
    {
		int sts;
		sts = posPtr.printerCheck();
		if(sts != ESCPOSConst.CMP_SUCCESS) return sts;
		
		sts = posPtr.status();
		if(sts != ESCPOSConst.CMP_SUCCESS) return sts;
		
        return ESCPOSConst.CMP_SUCCESS;
    }

	public int printingResults() throws UnsupportedEncodingException
    {
		int sts;
		sts = posPtr.printerCheck(5000, true);
		if(sts != ESCPOSConst.CMP_SUCCESS) return sts;
		
		sts = posPtr.status();
		if(sts != ESCPOSConst.CMP_SUCCESS) return sts;
		
		
		posPtr.printNormal(ESC + "|cA" + ESC + "|bC" + ESC + "|2C" + "Receipt" + LF + LF);
        posPtr.printNormal(ESC + "|rA" + ESC + "|bC" + "TEL (123)-456-7890" + LF);
        posPtr.printNormal(ESC + "|cA" + ESC + "|bC" + "Thank you for coming to our shop!" + LF + LF);

        posPtr.printNormal("Chicken                   $10.00" + LF);
        posPtr.printNormal("Hamburger                 $20.00" + LF);
        posPtr.printNormal("Pizza                     $30.00" + LF);
        posPtr.printNormal("Lemons                    $40.00" + LF);
        posPtr.printNormal("Drink                     $50.00" + LF + LF);
        posPtr.printNormal("Excluded tax             $150.00" + LF);

        posPtr.printNormal( ESC + "|uC" + "Tax(5%)                    $7.50" + LF);
        posPtr.printNormal( ESC + "|bC" + ESC + "|2C" + "Total   $157.50" + LF + LF);
        posPtr.printNormal( ESC + "|bC" + "Payment                  $200.00" + LF);
        posPtr.printNormal( ESC + "|bC" + "Change                    $42.50" + LF);

        posPtr.lineFeed(4);

        sts = posPtr.printerResults();

        return sts;
    }
}
