package com.citizen.escp.status.app.escpos;

import java.io.IOException;

import com.citizen.escp.status.app.escpos.R;
import com.citizen.escp.status.app.assist.AlertView;
import com.citizen.escp.status.app.assist.ESCPSample2;
import com.citizen.jpos.command.ESCPOSConst;

import android.app.AlertDialog;
import android.app.ListActivity;
import android.content.Context;
import android.content.DialogInterface;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.EditText;
import android.widget.LinearLayout;
import android.widget.Toast;
import android.widget.AdapterView.OnItemClickListener;

public class ESCP2Menu extends ListActivity
{
	private String TAG = "Sample2";
	private Context context;

	// Menu
	final static String[] arr = 
	{
		"Printer Status",
		"Printing results"
	};
	
	private String strCount;

	@Override
	protected void onDestroy()
	{
//		Log.d(TAG,"onDestroy()");
		super.onDestroy();
	}
	
	/** Called when the activity is first created. */
	@Override
	public void onCreate(Bundle savedInstanceState)
	{
		super.onCreate(savedInstanceState);
		context = this;

		setListAdapter(new ArrayAdapter<String>(this, android.R.layout.simple_list_item_1 , arr));
		getListView().setOnItemClickListener(new OnItemClickListener()
		{
			@Override
			public void onItemClick(AdapterView<?> arg0, View arg1, int arg2, long arg3)
			{
				dialog(arg2);
			}
		});
	}
	
	// Dialog
	private void dialog(int arg1)
	{
		final int arg2 = arg1;
		int retval = 0;
		ESCPSample2 sample = new ESCPSample2();					
		try
		{
			switch(arg2)
			{
			case 0:
				retval = sample.printerStatus();
				break;	
			case 1:
				retval = sample.printingResults();
				break;	
			default:
				break;
			}
		}
		catch(Exception e)
		{
			AlertView.showAlert(e.toString(), e.getMessage(), ESCP2Menu.this);
			Log.e(TAG,e.toString() +" "+ e.getMessage());
		}
		if(retval != ESCPOSConst.CMP_SUCCESS)
		{
			if(retval > 0)
			{
				switch(retval)
				{
				case ESCPOSConst.CMP_SUCCESS:
					AlertView.showAlert("Check success", context);
					break;
				case ESCPOSConst.CMP_STS_COVER_OPEN:
					AlertView.showAlert("Cover Open", context);
					break;
				case ESCPOSConst.CMP_STS_PAPER_EMPTY:
					AlertView.showAlert("Paper Empty", context);
					break;
				case ESCPOSConst.CMP_STS_PRINTEROFF:
					AlertView.showAlert("Power OFF", context);
					break;
				case ESCPOSConst.CMP_STS_BATTERY_LOW:
					AlertView.showAlert("Battery Low", context);
					break;
				default:
					AlertView.showAlert("No response\r\nPrinter error", context);
					break;
				}
			} else {
				String msg = "Return value = " + retval;
				// Printer check Error.
				AlertView.showAlert("Unknown error", msg, ESCP2Menu.this);
			}
		} else {
			switch(arg2)
			{
			case 0: // Check status.
				AlertView.showAlert("No errors", context);
				break;
			case 1: // Printing results.
				AlertView.showAlert("Printing success", context);
				break;
			}			
		}
	}
}