package com.pos.app.assist;

import java.io.IOException;
import java.io.UnsupportedEncodingException;

import com.citizen.jpos.command.CPCLConst;
import com.citizen.jpos.command.ESCPOS;
import com.citizen.jpos.command.ESCPOSConst;
import com.citizen.jpos.printer.CPCLPrinter;
import com.citizen.jpos.printer.ESCPOSPrinter;
import com.citizen.jpos.printer.CMPPrint;
import com.citizen.port.android.DeviceConnection;

import android.graphics.Typeface;
import android.util.Log;

public class Sample
{
	ESCPOSPrinter posPtr;
	final char ESC = ESCPOS.ESC;
	final char LF = ESCPOS.LF;
	
	public Sample(DeviceConnection connection)
	{
		posPtr = new ESCPOSPrinter(connection);
	}
	
	public void Sample1() throws UnsupportedEncodingException
	{
		posPtr.printNormal(ESC + "|cA" + ESC + "|bC" + ESC + "|2C" + "Receipt" + LF + LF);
        posPtr.printNormal(ESC + "|rA" + ESC + "|bC" + "TEL (123)-456-7890" + LF);
        posPtr.printNormal(ESC + "|cA" + ESC + "|bC" + "Thank you for coming to our shop!" + LF + LF);

        posPtr.printNormal("Chicken                   $10.00" + LF);
        posPtr.printNormal("Hamburger                 $20.00" + LF);
        posPtr.printNormal("Pizza                     $30.00" + LF);
        posPtr.printNormal("Lemons                    $40.00" + LF);
        posPtr.printNormal("Drink                     $50.00" + LF + LF);
        posPtr.printNormal("Excluded tax             $150.00" + LF);

        posPtr.printNormal( ESC + "|uC" + "Tax(5%)                    $7.50" + LF);
        posPtr.printNormal( ESC + "|bC" + ESC + "|2C" + "Total   $157.50" + LF + LF);
        posPtr.printNormal( ESC + "|bC" + "Payment                  $200.00" + LF);
        posPtr.printNormal( ESC + "|bC" + "Change                    $42.50" + LF);
        posPtr.printBarCode("1234567890", ESCPOSConst.CMP_BCS_Code39, 40, 2, ESCPOSConst.CMP_ALIGNMENT_CENTER, ESCPOSConst.CMP_HRI_TEXT_BELOW);         
        posPtr.printNormal(ESC + "|cA" + ESC + "|4C" + ESC + "|bC" + "Thank you" + LF);
        
        posPtr.lineFeed(3);
	}
	
	public void Sample2() throws UnsupportedEncodingException
	{
		posPtr.printBarCode("1234567890", ESCPOSConst.CMP_BCS_Code39, 40, 2, ESCPOSConst.CMP_ALIGNMENT_CENTER, ESCPOSConst.CMP_HRI_TEXT_BELOW);
        posPtr.printBarCode("0123498765", ESCPOSConst.CMP_BCS_Code93, 40, 2, ESCPOSConst.CMP_ALIGNMENT_CENTER, ESCPOSConst.CMP_HRI_TEXT_BELOW);
        posPtr.printBarCode("0987654321", ESCPOSConst.CMP_BCS_ITF, 40, 2, ESCPOSConst.CMP_ALIGNMENT_CENTER, ESCPOSConst.CMP_HRI_TEXT_BELOW);
        posPtr.printBarCode("{ACODE 128", ESCPOSConst.CMP_BCS_Code128, 40, 2, ESCPOSConst.CMP_ALIGNMENT_CENTER, ESCPOSConst.CMP_HRI_TEXT_BELOW);
        posPtr.printBarCode("{BCode 128", ESCPOSConst.CMP_BCS_Code128, 40, 2, ESCPOSConst.CMP_ALIGNMENT_CENTER, ESCPOSConst.CMP_HRI_TEXT_BELOW);
        posPtr.printBarCode("{C12345", ESCPOSConst.CMP_BCS_Code128, 40, 2, ESCPOSConst.CMP_ALIGNMENT_CENTER, ESCPOSConst.CMP_HRI_TEXT_BELOW);
        posPtr.printBarCode("A1029384756A", ESCPOSConst.CMP_BCS_Codabar, 40, 2, ESCPOSConst.CMP_ALIGNMENT_CENTER, ESCPOSConst.CMP_HRI_TEXT_BELOW);

        posPtr.lineFeed(3);

	}
	
	public void Sample3() throws IOException
	{
		posPtr.printBitmap("//sdcard//temp//test//logo_s.jpg", ESCPOSConst.CMP_ALIGNMENT_CENTER);
    	posPtr.printBitmap("//sdcard//temp//test//danmark_windmill.jpg", ESCPOSConst.CMP_ALIGNMENT_LEFT);
    	posPtr.printBitmap("//sdcard//temp//test//sample_2.jpg", ESCPOSConst.CMP_ALIGNMENT_RIGHT);
    	posPtr.printBitmap("//sdcard//temp//test//sample_3.jpg", ESCPOSConst.CMP_ALIGNMENT_CENTER);
    	posPtr.printBitmap("//sdcard//temp//test//sample_4.jpg", ESCPOSConst.CMP_ALIGNMENT_LEFT);
    
        posPtr.lineFeed(3);
	}
	
	public int Sample4() throws IOException
	{
		int check = posPtr.printerCheck();
    	if(check == ESCPOSConst.CMP_SUCCESS)
		{
    		Log.i("Sample","sts= "+posPtr.status());
    		return posPtr.status();
    	}
    	else
    	{
    		Log.i("Sample","Retrieve Status Failed");
    		return -1;
    	}
    }

    public int printAndroidFont() throws UnsupportedEncodingException
	{
    	int nLineWidth = 384;
    	String data = "Receipt";
//    	String data = "영수증";
    	Typeface typeface = null;

    	try
		{
			posPtr.printAndroidFont(data, nLineWidth, 100, ESCPOSConst.CMP_ALIGNMENT_CENTER);
			posPtr.lineFeed(2);
			posPtr.printAndroidFont("Left Alignment", nLineWidth, 24, ESCPOSConst.CMP_ALIGNMENT_LEFT);
			posPtr.printAndroidFont("Center Alignment", nLineWidth, 24, ESCPOSConst.CMP_ALIGNMENT_CENTER);
			posPtr.printAndroidFont("Right Alignment", nLineWidth, 24, ESCPOSConst.CMP_ALIGNMENT_RIGHT);

			posPtr.lineFeed(2);
			posPtr.printAndroidFont(Typeface.SANS_SERIF, "SANS_SERIF : 1234iwIW", nLineWidth, 24, ESCPOSConst.CMP_ALIGNMENT_LEFT);
			posPtr.printAndroidFont(Typeface.SERIF, "SERIF : 1234iwIW", nLineWidth, 24, ESCPOSConst.CMP_ALIGNMENT_LEFT);
			posPtr.printAndroidFont(Typeface.MONOSPACE, "MONOSPACE : 1234iwIW", nLineWidth, 24, ESCPOSConst.CMP_ALIGNMENT_LEFT);

			posPtr.lineFeed(2);
			posPtr.printAndroidFont(Typeface.SANS_SERIF, "SANS : 1234iwIW", nLineWidth, 24, ESCPOSConst.CMP_ALIGNMENT_LEFT);
			posPtr.printAndroidFont(Typeface.SANS_SERIF, true, "SANS BOLD : 1234iwIW", nLineWidth, 24, ESCPOSConst.CMP_ALIGNMENT_LEFT);
			posPtr.printAndroidFont(Typeface.SANS_SERIF, true, false, "SANS BOLD : 1234iwIW", nLineWidth, 24, ESCPOSConst.CMP_ALIGNMENT_LEFT);
			posPtr.printAndroidFont(Typeface.SANS_SERIF, false, true, "SANS ITALIC : 1234iwIW", nLineWidth, 24, ESCPOSConst.CMP_ALIGNMENT_LEFT);
			posPtr.printAndroidFont(Typeface.SANS_SERIF, true, true, "SANS BOLD ITALIC : 1234iwIW", nLineWidth, 24, ESCPOSConst.CMP_ALIGNMENT_LEFT);
			posPtr.printAndroidFont(Typeface.SANS_SERIF, true, true, true, "SANS B/I/U : 1234iwIW", nLineWidth, 24, ESCPOSConst.CMP_ALIGNMENT_LEFT);

			posPtr.lineFeed(2);
			posPtr.printAndroidFont(Typeface.SERIF, "SERIF : 1234iwIW", nLineWidth, 24, ESCPOSConst.CMP_ALIGNMENT_LEFT);
			posPtr.printAndroidFont(Typeface.SERIF, true, "SERIF BOLD : 1234iwIW", nLineWidth, 24, ESCPOSConst.CMP_ALIGNMENT_LEFT);
			posPtr.printAndroidFont(Typeface.SERIF, true, false, "SERIF BOLD : 1234iwIW", nLineWidth, 24, ESCPOSConst.CMP_ALIGNMENT_LEFT);
			posPtr.printAndroidFont(Typeface.SERIF, false, true, "SERIF ITALIC : 1234iwIW", nLineWidth, 24, ESCPOSConst.CMP_ALIGNMENT_LEFT);
			posPtr.printAndroidFont(Typeface.SERIF, true, true, "SERIF BOLD ITALIC : 1234iwIW", nLineWidth, 24, ESCPOSConst.CMP_ALIGNMENT_LEFT);
			posPtr.printAndroidFont(Typeface.SERIF, true, true, true, "SERIF B/I/U : 1234iwIW", nLineWidth, 24, ESCPOSConst.CMP_ALIGNMENT_LEFT);

			posPtr.lineFeed(2);
			posPtr.printAndroidFont(Typeface.MONOSPACE, "MONOSPACE : 1234iwIW", nLineWidth, 24, ESCPOSConst.CMP_ALIGNMENT_LEFT);
			posPtr.printAndroidFont(Typeface.MONOSPACE, true, "MONO BOLD : 1234iwIW", nLineWidth, 24, ESCPOSConst.CMP_ALIGNMENT_LEFT);
			posPtr.printAndroidFont(Typeface.MONOSPACE, true, false, "MONO BOLD : 1234iwIW", nLineWidth, 24, ESCPOSConst.CMP_ALIGNMENT_LEFT);
			posPtr.printAndroidFont(Typeface.MONOSPACE, false, true, "MONO ITALIC : 1234iwIW", nLineWidth, 24, ESCPOSConst.CMP_ALIGNMENT_LEFT);
			posPtr.printAndroidFont(Typeface.MONOSPACE, true, true, "MONO BOLD ITALIC: 1234iwIW", nLineWidth, 24, ESCPOSConst.CMP_ALIGNMENT_LEFT);
			posPtr.printAndroidFont(Typeface.MONOSPACE, true, true, true, "MONO B/I/U: 1234iwIW", nLineWidth, 24, ESCPOSConst.CMP_ALIGNMENT_LEFT);

			posPtr.lineFeed(4);
		}
		catch (IOException e)
		{
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

    	return 0;
	}	

    public int printMultilingualFont() throws UnsupportedEncodingException
	{
    	int nLineWidth = 384;
    	String Koreandata = "영수증";
    	String Turkishdata = "Turkish(İ,Ş,Ğ)";
    	String Russiandata = "Получение";
    	String Arabicdata = "الإيصال";
    	String Greekdata = "Παραλαβή";
    	String Japanesedata = "領収書";
    	String GB2312data = "收据";
    	String BIG5data = "收據";

    	try
		{
			posPtr.printAndroidFont("Korean Font", nLineWidth, 24, ESCPOSConst.CMP_ALIGNMENT_LEFT);
    		// Korean 100-dot size font in android device.
        	posPtr.printAndroidFont(Koreandata, nLineWidth, 100, ESCPOSConst.CMP_ALIGNMENT_CENTER);

			posPtr.printAndroidFont("Turkish Font", nLineWidth, 24, ESCPOSConst.CMP_ALIGNMENT_LEFT);
    		// Turkish 50-dot size font in android device.
        	posPtr.printAndroidFont(Turkishdata, nLineWidth, 50, ESCPOSConst.CMP_ALIGNMENT_CENTER);

			posPtr.printAndroidFont("Russian Font", 384, 24, ESCPOSConst.CMP_ALIGNMENT_LEFT);
    		// Russian 60-dot size font in android device.
        	posPtr.printAndroidFont(Russiandata, nLineWidth, 60, ESCPOSConst.CMP_ALIGNMENT_CENTER);

			posPtr.printAndroidFont("Arabic Font", nLineWidth, 24, ESCPOSConst.CMP_ALIGNMENT_LEFT);
    		// Arabic 100-dot size font in android device.
        	posPtr.printAndroidFont(Arabicdata, nLineWidth, 100, ESCPOSConst.CMP_ALIGNMENT_CENTER);

			posPtr.printAndroidFont("Greek Font", nLineWidth, 24, ESCPOSConst.CMP_ALIGNMENT_LEFT);
    		// Greek 60-dot size font in android device.
        	posPtr.printAndroidFont(Greekdata, nLineWidth, 60, ESCPOSConst.CMP_ALIGNMENT_CENTER);

			posPtr.printAndroidFont("Japanese Font", nLineWidth, 24, ESCPOSConst.CMP_ALIGNMENT_LEFT);
        	// Japanese 100-dot size font in android device.
        	posPtr.printAndroidFont(Japanesedata, nLineWidth, 100, ESCPOSConst.CMP_ALIGNMENT_CENTER);

			posPtr.printAndroidFont("GB2312 Font", nLineWidth, 24, ESCPOSConst.CMP_ALIGNMENT_LEFT);
    		// GB2312 100-dot size font in android device.
        	posPtr.printAndroidFont(GB2312data, nLineWidth, 100, ESCPOSConst.CMP_ALIGNMENT_CENTER);

			posPtr.printAndroidFont("BIG5 Font", nLineWidth, 24, ESCPOSConst.CMP_ALIGNMENT_LEFT);
    		// BIG5 100-dot size font in android device.
        	posPtr.printAndroidFont(BIG5data, nLineWidth, 100, ESCPOSConst.CMP_ALIGNMENT_CENTER);

        	posPtr.lineFeed(4);
		}
		catch (IOException e)
		{
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

    	return 0;
	}

	public int ESCPOSprintingResults() throws UnsupportedEncodingException
    {
		int sts;
		sts = posPtr.printerCheck(3000, true);
		if(sts != ESCPOSConst.CMP_SUCCESS) return ESCPOSConst.CMP_FAIL;

		posPtr.printNormal(ESC+"|cA"+ESC+"|2CReceipt\r\n\r\n\r\n");
		posPtr.printNormal(ESC+"|rATEL (123)-456-7890\n\n\n");
		posPtr.printNormal(ESC+"|cAThank you for coming to our shop!\n");
		posPtr.printNormal(ESC+"|cADate\n\n");
		posPtr.printNormal("Chicken                             $10.00\n");
		posPtr.printNormal("Hamburger                           $20.00\n");
		posPtr.printNormal("Pizza                               $30.00\n");
		posPtr.printNormal("Lemons                              $40.00\n");
		posPtr.printNormal("Drink                               $50.00\n");
		posPtr.printNormal("Excluded tax                       $150.00\n");
		posPtr.printNormal(ESC+"|uCTax(5%)                              $7.50\n");
		posPtr.printNormal(ESC+"|bC"+ESC+"|2CTotal         $157.50\n\n");
		posPtr.printNormal("Payment                            $200.00\n");
		posPtr.printNormal("Change                              $42.50\n\n");
		posPtr.printBarCode("{Babc456789012", CMPPrint.CMP_BCS_Code128, 40, 512, CMPPrint.CMP_ALIGNMENT_CENTER, CMPPrint.CMP_HRI_TEXT_BELOW); // Print Barcode
       
		sts = posPtr.printerResults();

        return sts;
    }
	
	public int CPCLprintingResults(DeviceConnection connection) throws UnsupportedEncodingException
    {
		int nLineWidth = 384, pResults = 0;
		String data = "Receipt";
		Typeface typeface = null;

		CPCLPrinter cpclPrinter = new CPCLPrinter(connection);

		try
		{
			cpclPrinter.setForm(0, 200, 200, 406, 1);
			cpclPrinter.setMedia(CPCLConst.CMP_CPCL_CONTINUOUS);

			cpclPrinter.printAndroidFont(data, nLineWidth, 100, 0, CPCLConst.CMP_CPCL_CENTER);
			cpclPrinter.printAndroidFont("Left Alignment", nLineWidth, 24, 120, CPCLConst.CMP_CPCL_LEFT);
			cpclPrinter.printAndroidFont("Center Alignment", nLineWidth, 24, 150, CPCLConst.CMP_CPCL_CENTER);
			cpclPrinter.printAndroidFont("Right Alignment", nLineWidth, 24, 180, CPCLConst.CMP_CPCL_RIGHT);

			cpclPrinter.printAndroidFont(Typeface.SANS_SERIF, "SANS_SERIF : 1234iwIW", nLineWidth, 24, 210, CPCLConst.CMP_CPCL_LEFT);
			cpclPrinter.printAndroidFont(Typeface.SERIF, "SERIF : 1234iwIW", nLineWidth, 24, 240, CPCLConst.CMP_CPCL_LEFT);
			cpclPrinter.printAndroidFont(typeface.MONOSPACE, "MONOSPACE : 1234iwIW", nLineWidth, 24, 270, CPCLConst.CMP_CPCL_LEFT);

			// Print
			cpclPrinter.printForm();
			pResults = cpclPrinter.printerResults(5000);
			return pResults;
		}
		catch (IOException e)
		{
			// TODO Auto-generated catch block
			e.printStackTrace();
			return CPCLConst.CMP_FAIL;
		}
    }

}
